# Needs packages:
#library(urbanR)
library(gbm)
library(lubridate)
library(plyr) #OJO! la llibreria plyr ha de ser cridada abans que dplyr 
library(dplyr) #per treballar amb cbinds i esas cosas
library(caret)
library(zoo)
library(scatterplot3d)
library(plotly)

#borrar
#library(RNetCDF)
library(sp)
library(sf)
library(mapview)
#library(ncdf4)
#library(rgeos) 
library(ggplot2)
#library(broom)
#library(magrittr)
#library(ggpubr)
library(raster)
#library(rgdal)
#library(tmap)
library(gstat)
#library(abind)
#library(rbind)
library(openair)
#library(tidyr)




UK_gene_20190121 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5_sensegbm/UK_gene_pm2p5_20190121.rds")

mean_persist_senia <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_persist_senia-100.rds")
mean_persist_eixample <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_persist_eixample-100.rds")
mean_linterpol_senia <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_linterpol_senia-100.rds")
mean_linterpol_eixample <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_linterpol_eixample-100.rds")
mean_gbm_senia_n3 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_senia-100.rds")
mean_gbm_eixample_n3 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_eixample-100.rds")


summary_mean_bench <- rbind(mean_gbm_eixample_n3[1,], 
                            mean_linterpol_eixample[1,],
                            mean_persist_eixample[1,], 
                            mean_gbm_senia_n3[1,], 
                            mean_linterpol_senia[1, ], 
                            mean_persist_senia[1,])

rownames(summary_mean_bench) <- c("gbm_eixample", "interpol_eixample", "persist_eixample", "gbm_senia","interpol_senia", "persist_senia")

#save_path    <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/"
#saveRDS(object=summary_mean_bench, file=paste0(save_path,"summary_mean_bench-100.rds"))



# bench GBM --------------------------------------------------------------------------


mean_gbm_senia_n3 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_senia-100.rds")
mean_gbm_eixample_n3 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_eixample-100.rds")


#mean_gbm_senia_1 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_senia-10_1.rds")
#mean_gbm_eixample_1 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_eixample-10_1.rds")
#mean_gbm_senia_2 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_senia-30_2.rds")
#mean_gbm_eixample_2 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_eixample-30_2.rds")
#mean_gbm_senia_3 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_senia-70_3.rds")
#mean_gbm_eixample_3 <- readRDS("/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/mean_gbm_eixample-70_3.rds")


#mean_gbm_senia_123 <- rbind(mean_gbm_senia_1, mean_gbm_senia_2, mean_gbm_senia_3)
#mean_gbm_senia_ada <- mean_gbm_senia_123  %>%
  #as.data.frame() %>%
  #group_by(gap_size, train_fraction) %>%
  #dplyr::summarise(r_mean= mean(r_mean), r_std = sd(r_std), MB_mean= mean(MB_mean), MB_std = sd(MB_std), RMSE_mean = mean(RMSE_mean), RMSE_std = sd(RMSE_std))

#save_path    <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/"
#saveRDS(object=mean_gbm_senia_ada, file=paste0(save_path,"mean_gbm_eixample-100_pcada.rds"))

#mean_gbm_eixample_123 <- rbind(mean_gbm_eixample_1, mean_gbm_eixample_2, mean_gbm_eixample_3)
#mean_gbm_eixample_ada <- mean_gbm_eixample_123  %>%
  #as.data.frame() %>%
  #group_by(gap_size, train_fraction) %>%
  #dplyr::summarise(r_mean= mean(r_mean), r_std = sd(r_std), MB_mean= mean(MB_mean), MB_std = sd(MB_std), RMSE_mean = mean(RMSE_mean), RMSE_std = sd(RMSE_std))

#save_path    <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/GBM_eval/"
#saveRDS(object=mean_gbm_senia_ada, file=paste0(save_path,"mean_gbm_eixample-100_pcada.rds"))



# plotting bench ---------------------------------------------------------------------------
ggplot(mean_gbm_senia_n3, aes(x = gap_size, y = r_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats gbm La Sènia",
       x = "gap_size",
       y = "r_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +  # paleta de colores magma?
  theme_minimal() +
  ylim(0, 1) 

ggplot(mean_gbm_eixample_n3, aes(x = gap_size, y = r_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats gbm Eixample",
       x = "gap_size",
       y = "r_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() + 
  theme_minimal() +
  ylim(0, 1) 


#a leix x train fraction
r_train_senia_gbm <- ggplot(mean_gbm_senia_n3, aes(x = train_fraction, y = r_mean, color = as.factor(gap_size))) +
  geom_line() +
  labs(title = "GBM La Sènia",
       x = "Train fraction",
       y = "r", 
       color = "Gap size") +
  scale_color_viridis_d() +  # paleta de colores magma?
  theme_bw() +
  ylim(0.6, 0.75) 

r_train_eix_gbm <- ggplot(mean_gbm_eixample_n3, aes(x = train_fraction, y = r_mean, color = as.factor(gap_size))) +
  geom_line() +
  labs(title = "GBM Eixample",
       x = "Train fraction",
       y = "r", 
       color = "Gap size") +
  scale_color_viridis_d() + 
  theme_bw() +
  ylim(0.6, 0.75) 

r_train_senia_gbm
r_train_eix_gbm

save_plots <- "/home/abarrant/Documents/TFM/images/benchmark/"
ggsave(paste0(save_plots, "r_train_senia_gbm.png"), plot = r_train_senia_gbm, width = 8, height = 6)
ggsave(paste0(save_plots, "r_train_eix_gbm.png"), plot = r_train_eix_gbm, width = 8, height = 6)

## MB mean value ----------------------------------------------------------------
ggplot(mean_gbm_senia_n3, aes(x = gap_size, y = MB_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats gbm La Sènia",
       x = "gap_size",
       y = "MB_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +
  theme_minimal() +
  ylim(-1, 1) #ajustar limits 

ggplot(mean_gbm_eixample_n3, aes(x = gap_size, y = MB_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title =  "Stats gbm Eixample",
       x = "gap_size",
       y = "MB_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +  
  theme_minimal() +
  ylim(-1, 1) 


ggplot(mean_linterpol_senia, aes(x = gap_size, y = MB_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats linear interpol La Sènia",
       x = "gap_size",
       y = "MB_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +
  theme_minimal()  +
  ylim(-1, 1) #ajustar limits 

ggplot(mean_persist_senia, aes(x = gap_size, y = MB_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats persistence La Sènia",
       x = "gap_size",
       y = "MB_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +  
  theme_minimal() +
  ylim(-1, 1) 

#eixample
ggplot(mean_linterpol_eixample, aes(x = gap_size, y = MB_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats linear interpol Eixample",
       x = "gap_size",
       y = "MB_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +
  theme_minimal()  +
  ylim(-1, 1) #ajustar limits 

ggplot(mean_persist_eixample, aes(x = gap_size, y = MB_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats persistence Eixample",
       x = "gap_size",
       y = "MB_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +  
  theme_minimal() +
  ylim(-1, 1) 

## RMSE mean value ---------------------------------------------------------------

ggplot(mean_gbm_senia_n3, aes(x = gap_size, y = RMSE_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats gbm La Sènia",
       x = "gap_size",
       y = "RMSE_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +
  theme_minimal()  +
  ylim(2, 9) #ajustar limits 

ggplot(mean_gbm_eixample_n3, aes(x = gap_size, y = RMSE_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title =  "Stats gbm Eixample",
       x = "gap_size",
       y = "RMSE_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +  
  theme_minimal() +
  ylim(2, 9) 

ggplot(mean_linterpol_senia, aes(x = gap_size, y = RMSE_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats linear interpol La Sènia",
       x = "gap_size",
       y = "RMSE_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +
  theme_minimal()  +
  ylim(2, 9) #ajustar limits 

ggplot(mean_persist_senia, aes(x = gap_size, y = RMSE_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats persistence La Sènia",
       x = "gap_size",
       y = "RMSE_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +  
  theme_minimal() +
  ylim(2, 9) 

#exiample
ggplot(mean_linterpol_eixample, aes(x = gap_size, y = RMSE_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats linear interpol Eixample",
       x = "gap_size",
       y = "RMSE_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +
  theme_minimal()  +
  ylim(2, 9) #ajustar limits 

ggplot(mean_persist_eixample, aes(x = gap_size, y = RMSE_mean, color = as.factor(train_fraction))) +
  geom_line() +
  labs(title = "Stats persistence Eixample",
       x = "gap_size",
       y = "RMSE_mean", 
       color = "Train fraction") +
  scale_color_viridis_d() +  
  theme_minimal() +
  ylim(2, 9) 

# mitjanes per qualsevol train fraction -------------------------------------------

mean_trainfraction <- function(df, meto) {
  mean_train_df <- df  %>%
    as.data.frame() %>%
    group_by(gap_size) %>%
    dplyr::summarise(r_mean = mean(r_mean), r_std_mean = mean(r_std), MB_mean= mean(MB_mean), MB_std_mean = mean(MB_std), RMSE_mean = mean(RMSE_mean), RMSE_std = mean(RMSE_std))
  
  mean_train_df$method <- meto
  return(mean_train_df)
}

mean_gapsize <- function(df, meto) {
  mean_train_df <- df  %>%
    as.data.frame() %>%
    group_by(train_fraction) %>%
    dplyr::summarise(r_mean = mean(r_mean), r_std_mean = mean(r_std), MB_mean= mean(MB_mean), MB_std_mean = mean(MB_std), RMSE_mean = mean(RMSE_mean), RMSE_std = mean(RMSE_std))
  
  mean_train_df$method <- meto
  return(mean_train_df)
}

#mean gaps size
mean_gap_gbm_eixample <- mean_gapsize(mean_gbm_eixample_n3, "GBM Eixample")
mean_gap_linterpol_eixample <- mean_gapsize(mean_linterpol_eixample, "Linear interpolation Eixample")
mean_gap_persist_eixample <- mean_gapsize(mean_persist_eixample, "Persistence Eixample")

mean_gap_gbm_senia <- mean_gapsize(mean_gbm_senia_n3, "GBM La Sènia")
mean_gap_linterpol_senia <- mean_gapsize(mean_linterpol_senia, "Linear interpolation La Sènia")
mean_gap_persist_senia <- mean_gapsize(mean_persist_senia, "Persistence La Sènia")

summary_train <- rbind(mean_gap_gbm_eixample, mean_gap_linterpol_eixample, mean_gap_persist_eixample, mean_gap_gbm_senia, mean_gap_linterpol_senia, mean_gap_persist_senia)


#mean train fraction
mean_train_gbm_eixample <- mean_trainfraction(mean_gbm_eixample_n3, "GBM Eixample")
mean_train_linterpol_eixample <- mean_trainfraction(mean_linterpol_eixample, "Linear interpolation Eixample")
mean_train_persist_eixample <- mean_trainfraction(mean_persist_eixample, "Persistence Eixample")

mean_train_gbm_senia <- mean_trainfraction(mean_gbm_senia_n3, "GBM La Sènia")
mean_train_linterpol_senia <- mean_trainfraction(mean_linterpol_senia, "Linear interpolation La Sènia")
mean_train_persist_senia <- mean_trainfraction(mean_persist_senia, "Persistence La Sènia")

summary_eixample <- rbind(mean_train_gbm_eixample, mean_train_linterpol_eixample, mean_train_persist_eixample)
summary_senia <- rbind(mean_train_gbm_senia, mean_train_linterpol_senia, mean_train_persist_senia)

summary_gaps <- rbind(mean_train_gbm_eixample, mean_train_linterpol_eixample, mean_train_persist_eixample, mean_train_gbm_senia, mean_train_linterpol_senia, mean_train_persist_senia)

save_path      <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"
#saveRDS(object=summary_gaps, file=paste0(save_path,"summary_gaps_benchmark.rds"))
#summary_gaps <- readRDS(paste0(save_path, "summary_gaps_benchmark.rds"))


### GRAFICA CONJUNTA R, EN FUNCIO GAP SIZE
colors <- c("GBM Eixample" = "darkblue", "Linear interpolation Eixample" = "lightseagreen", "Persistence Eixample" = "goldenrod", "GBM La Sènia" = "darkblue", "Linear interpolation La Sènia" = "lightseagreen", "Persistence La Sènia" = "goldenrod")
line_types <- c("GBM Eixample" = "solid", "Linear interpolation Eixample" = "solid", "Persistence Eixample" = "solid", "GBM La Sènia" = "dashed", "Linear interpolation La Sènia" = "dashed", "Persistence La Sènia" = "dashed")

ggplot(summary_gaps, aes(x = gap_size, y = r_mean, color = as.factor(method), linetype = as.factor(method))) +
  geom_line() +
  labs(x = "Gap size",   #title = "Summary mean train fraction",
       y = "Mean r ", 
       color = "Methodology",
       linetype = "Methodology") +
  scale_color_manual(values = colors) +
  scale_linetype_manual(values = line_types) +
  theme_bw() +
  ylim(0, 1) +
  theme(legend.position = "none",
        plot.title = element_text(size = 23),  # Increase title size
        axis.title.x = element_text(size = 23),  # Increase x-axis title size
        axis.title.y = element_text(size = 23),  # Increase y-axis title size
        axis.text.x = element_text(size = 16),  # Increase x-axis text size
        axis.text.y = element_text(size = 16)   # Increase y-axis text size
  ) #+
  #theme(legend.position = c(0.8, 0.2))

ggplot(summary_gaps, aes(x = gap_size, y = MB_mean, color = as.factor(method), linetype = as.factor(method))) +
  geom_line() +
  labs(x = "Gap size",   #title = "Summary mean train fraction",
       y = expression("Mean MB (" * mu * "g/m"^3 * ")"), 
       color = "Methodology",
       linetype = "Methodology") +
  scale_color_manual(values = colors) +
  scale_linetype_manual(values = line_types) +
  theme_bw() +
  ylim(-0.2, 0.2) +
  geom_hline(yintercept = 0, color = "black", size = 0.15) +
  theme(
    plot.title = element_text(size = 23),  # Increase title size
    axis.title.x = element_text(size = 23),  # Increase x-axis title size
    axis.title.y = element_text(size = 23),  # Increase y-axis title size
    axis.text.x = element_text(size = 16),  # Increase x-axis text size
    axis.text.y = element_text(size = 16),   # Increase y-axis text size
    legend.title = element_text(size = 20),  # Increase legend title size
    legend.text = element_text(size = 12)
  ) #+
#theme(legend.position = c(0.8, 0.2))


ggplot(summary_train, aes(x = train_fraction, y = r_mean, color = as.factor(method), linetype = as.factor(method))) +
  geom_line() +
  labs(title = "Summary mean gap size",
       x = "Train Fraction",
       y = "Mean r ", 
       color = "Methodolody",
       linetype = "Methodolody") +
  scale_color_manual(values = colors) +
  scale_linetype_manual(values = line_types) +
  theme_bw() +
  ylim(0, 1)

#MB
ggplot(summary_gaps, aes(x = gap_size, y = MB_mean, color = as.factor(method), linetype = as.factor(method))) +
  geom_line() +
  labs(title = "Summary mean train fraction",
       x = "Gap size",
       y = "Mean MB", 
       color = "Methodolody",
       linetype = "Methodolody") +
  scale_color_manual(values = colors) +
  scale_linetype_manual(values = line_types) +
  theme_bw() +
  ylim(-0.3, 0.3) #+
#theme(legend.position = c(0.8, 0.2))

ggplot(summary_train, aes(x = train_fraction, y = MB_mean, color = as.factor(method), linetype = as.factor(method))) +
  geom_line() +
  labs(title = "Summary mean gap size",
       x = "Train Fraction",
       y = "Mean MB", 
       color = "Methodolody",
       linetype = "Methodolody") +
  scale_color_manual(values = colors) +
  scale_linetype_manual(values = line_types) +
  theme_bw() +
  ylim(-0.3, 0.3)

#RMSE
ggplot(summary_gaps, aes(x = gap_size, y = RMSE_mean, color = as.factor(method), linetype = as.factor(method))) +
  geom_line() +
  labs(title = "Summary mean train fraction",
       x = "Gap size",
       y = "Mean RMSE ", 
       color = "Methodolody",
       linetype = "Methodolody") +
  scale_color_manual(values = colors) +
  scale_linetype_manual(values = line_types) +
  theme_bw() +
  ylim(2, 9) #+
#theme(legend.position = c(0.8, 0.2))

ggplot(summary_train, aes(x = train_fraction, y = RMSE_mean, color = as.factor(method), linetype = as.factor(method))) +
  geom_line() +
  labs(title = "Summary mean gap size",
       x = "Train Fraction",
       y = "Mean RMSE ", 
       color = "Methodolody",
       linetype = "Methodolody") +
  scale_color_manual(values = colors) +
  scale_linetype_manual(values = line_types) +
  theme_bw() +
  ylim(2, 9)

#-----------------------------------------------------------------------------------
#individuals

ggplot(summary_eixample, aes(x = gap_size, y = r_mean, color = as.factor(method))) +
  geom_line() +
  labs(title = "Summary Stats Eixample",
       x = "Gap size",
       y = "Mean r ", 
       color = "Methodolody") +
  theme_bw() +
  ylim(0, 1) #ajustar limits 

ggplot(summary_senia, aes(x = gap_size, y = r_mean, color = as.factor(method))) +
  geom_line() +
  labs(title = "Summary Stats La Sènia",
       x = "Gap size",
       y = "Mean r", 
       color = "Methodolody") +
  theme_bw() +
  ylim(0, 1) #ajustar limits 



ggplot(summary_eixample, aes(x = gap_size, y = MB_mean, color = as.factor(method))) +
  geom_line() +
  labs(title = "Summary Stats Eixample",
       x = "Gap size",
       y = "Mean MB ", 
       color = "Methodolody") +
  theme_bw() +
  ylim(-0.25, 0.25) #ajustar limits 

ggplot(summary_senia, aes(x = gap_size, y = MB_mean, color = as.factor(method))) +
  geom_line() +
  labs(title = "Summary Stats La Sènia",
       x = "Gap size",
       y = "Mean MB", 
       color = "Methodolody") +
  theme_bw() +
  ylim(-0.25, 0.25) #ajustar limits 



ggplot(summary_eixample, aes(x = gap_size, y = RMSE_mean, color = as.factor(method))) +
  geom_line() +
  labs(title = "Summary Stats Eixample",
       x = "Gap size",
       y = "Mean RMSE ", 
       color = "Methodolody") +
  theme_bw() +
  ylim(2, 9) #ajustar limits 

ggplot(summary_senia, aes(x = gap_size, y = RMSE_mean, color = as.factor(method))) +
  geom_line() +
  labs(title = "Summary Stats La Sènia",
       x = "Gap size",
       y = "Mean RMSE", 
       color = "Methodolody") +
  theme_bw() +
  ylim(2, 9) #ajustar limits 