#library(urbanR)
#library(RNetCDF)
library(sp)
library(sf)
#library(mapview)
#library(ncdf4)
#library(rgeos) 
library(ggplot2)
library(plyr) #OJO! la llibreria plyr ha de ser cridada abans que dplyr 
library(dplyr) 
#library(broom)
#library(magrittr)
library(ggpubr)
library(raster)
#library(rgdal)
#library(tmap)
library(gstat)
library(sp)
library(abind)
library(openair)
library(tidyr)
#library(RColorBrewer)
#library(Metrics)
#library(gbm)
#library(lubridate)
#library(matrixStats)
library(leaflet)
library(viridis)
library(viridisLite)





path_sp      <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"

pixels_UK_gbm <- readRDS(paste0(path_sp, "annual_pixels_UK_gbm.rds"))
pixels_UK     <- readRDS(paste0(path_sp, "annual_pixels_UK.rds"))
pixels_count_gbm <- readRDS(paste0(path_sp, "annual_pixels_count_daylimit_UK_GBM.rds"))





ggplot() + 
  geom_tile(as.data.frame(pixels_UK), mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno", limits=c(5, 25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )


ggplot() + 
  geom_tile(as.data.frame(pixels_UK_gbm), mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno", limits=c(5, 25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )






df_delta <- as.data.frame(pixels_UK)
df_uk <- as.data.frame(pixels_UK)
df_uk_gbm <- as.data.frame(pixels_UK_gbm)

df_delta$var1.pred <- df_uk_gbm$var1.pred - df_uk$var1.pred


ggplot() + 
  geom_tile(df_delta, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno") +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )




ggplot() + 
  geom_tile(df_uk, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_stepsn(colors=c( "#7F3F80", "#CF5A8B", "#F4A54B", "yellow2"),breaks=c(5,10,15,20,25), limits=c(5,25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill = expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )

ggplot() + 
  geom_tile(df_uk_gbm, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_stepsn(colors=c( "#7F3F80", "#CF5A8B", "#F4A54B", "yellow2"),breaks=c(5,10,15,20,25), limits=c(5,25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill = expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )



